org 100h
bits 16


START:


_x86_Portable__PLATFORMBITS_ equ 1632

jmp start2

%include "00000000__x86_Portable.asm"

start2:



 ;Inputs:
 ;       DX -- Main Sound Blaster port (0x220, etc...COMPLETE)
 ;
 ;Outputs:
 ;        AL -- DSP version
 ;        Carry Flag (CF) -- 1==Error, 0==OK
 ;;
  mov dx,0x220
  call OPCODE__ResetDSP
  jc .enderr

 ;Print the received value in AL
 ;for the DSP version:
 ;;
;   mov wideax,5          ;Value to print
   mov widebp,11111111b  ;Set the bitmask of bits to print
   call _tmp_prn_bindechex



  push wideax
  push widedx
  mov ah,9
  mov dx,rnstr
  int 21h
  pop widedx
  pop wideax




 jmp .end
 .enderr:


 ;Print the error string:
 ;;
  mov dx,sbtest0errstr
  mov ah,9
  int 21h

  mov dx,rnstr
  mov ah,9
  int 21h






 .end:


mov ax,0x4C00
int 21h






















;Inputs:
;       DX -- Main Sound Blaster port (0x220, etc...COMPLETE)
;
;Outputs:
;        Carry Flag (CF) -- 1==Error, 0==OK
;        --------------
;        All other flags are undefined
;;
OPCODE__wait_DSP_DATA_AVAIL:
 push wideax
 push widecx



 ;Loop to wait that the DSP_DATA_AVAIL port
 ;byte value to become 1 at bit 7:
 ;;
  add dx,14     ;Point to DSP_DATA_AVAIL
  mov widecx,0xFFFFF
  .waitloop:

   ;See if the port already contains bit_7==1.
   ;If so, end the loop (what does it mean???COMPLETE):
   ;;
    in al,dx
	test al,10000000b    ;(0x80, 128)
    jnz .waitloop_end


  loop .waitloop
  .waitloop_end:
  sub dx,14     ;Point back from DPS_DATA_AVAIL





 ;If WIDECX is 0, it means that
 ;we waited without a good result,
 ;so we must indicate an error
 ;(obviously an absent or non-functional
 ;Sound Blaster DSP at that I/O port):
 ;;
  cmp widecx,0
  je .nok
   clc

  jmp .end
  .nok:
   stc







 .end:

 pop widecx
 pop wideax
retwide


















;Inputs:
;       DX -- Main Sound Blaster port (0x220, etc...COMPLETE)
;
;Outputs:
;        AL -- DSP version
;        Carry Flag (CF) -- 1==Error, 0==OK
;;
OPCODE__ResetDSP:
 push wideax
 push widebx



 ;Send a byte value 1 to the Sound Blaster
 ;DSP Reset port (for what......?):
 ;;
  add dx,6
  mov al,1
  out dx,al
  sub dx,6
 ;
   ;;
   ;;;
   ;;;;
    ;;
   ;;;;
  ;;;;;;
 ;;;;;;;;



 ;Wait 10 milliseconds for the reset.
 ;
 ;Here we want to wait 10,000 microseconds s,
 ;but we will round it to 16384 microseconds
 ;to compensate for timing imprecisions which
 ;we could only compensate better if we actually
 ;used FPU floating point values to measure
 ;fractions of time units, but since PIT_8253_4__kwait
 ;doesn't do that (PIT_8253_4__fkwait would, using
 ;probably FPU registers instead of CPU ones, or a variable,
 ;or 2 CPU registers.......),
 ;we are compensating here in that way:
 ;;
  push widecx
  mov widecx,16384
  loop $
  pop widecx



 ;;;;;;;;
  ;;;;;;
   ;;;;
    ;;
   ;;;;
   ;;;
   ;;
 ;
 ;Send a byte value 0 to the Sound Blaster
 ;DSP Reset port (for what......?):
 ;;
  add dx,6
  mov al,0
  out dx,al
  sub dx,6


 ;Wait (why?COMPLETE):
 ;;
  call OPCODE__wait_DSP_DATA_AVAIL
  jc .enderr

 ;See if the DSP_READ_PORT (10) contains DSP_READY (0xAA):
 ;If it doesn't, we will have to end with error:
 ;;
  add dx,10
  in al,dx
  sub dx,10

  cmp al,0xAA
  jne .enderr



   ;;;INIT: DSP_READY == 0xAA
   ;;;INIT: DSP_READY == 0xAA
   ;;;INIT: DSP_READY == 0xAA
   ;;;INIT: DSP_READY == 0xAA

     ;Write the DSP_WRITE_PORT (12)
     ;and ask for the DSP_VERSION (0xE1):
     ;;
      add dx,12
      mov al,0xE1
      out dx,al
      sub dx,12

     ;Wait (why?COMPLETE):
     ;;
      call OPCODE__wait_DSP_DATA_AVAIL
      jc .enderr

     ;Read the DSP_READ_PORT. It should now contain
     ;the Sound Blaster DSP version, for example,
     ;a byte value of 4:
     ;;
      add dx,10
      in al,dx
      sub dx,10




   ;;;END:  DSP_READY == 0xAA
   ;;;END:  DSP_READY == 0xAA
   ;;;END:  DSP_READY == 0xAA
   ;;;END:  DSP_READY == 0xAA




 clc  ;Indicate OK
 jmp .end



 .enderr:
 stc




 .end:
 mov widebx,wideax

 pop wideax
 mov al,bl
 pop widebx
retwide








num2str_endchar equ '$'



;NOTE: This function should be exported by the kernel...
;      It should also preserve FLAGS, not let them be left altered
;;

;/*
; Inputs:
;        BL  -- base to convert to
;        EAX -- binary value to convert to string
;        EDI -- end of intended string (since the string
;               is generated backwards)
;
; Outputs:
;        ECX -- lenght of string
;        EDI -- start of the generated string
;
;*/
num2str:
 push eax
 push ebx
 push edx
 push ebp


 and ebx,11111111b;
 xor ecx,ecx;


  mov byte[edi],num2str_endchar
  dec edi


 cmp eax,0
 jnz .noeax0;
   inc ecx;
   mov byte[edi],'0';
   jmp .end;
 .noeax0:


 .while_ln_534543:
 cmp eax,0
 jz .while_ln_534543_end

  inc ecx;
  

  ;//Clear EDX for the 32-bit-only division
  ;//and perform the assembly division:
  ;;
   xor edx,edx;
       div ebx;   ;//EDX:EAX / EBX == EAX quotient
                  ;//                 EDX remainder


  ;//Take a copy of the remainder:
  ;;
   mov ebp,edx;


  ;//Convert binary remainder to ASCII value:
  ;;
   cmp dl,0
   jb .try10
   cmp dl,9
   ja .try10;
    add dl,0x30;  ;// '0' to '9'
   jmp .endif


   .try10:
   cmp dl,10
   jb .endif
    add dl,(0x41-10);  ;// 'A' and beyond


   .endif:


  ;//Put the character in the string:
  ;;
   mov byte[edi],dl;





  dec edi;


 jmp .while_ln_534543;
 .while_ln_534543_end:



  inc edi;





 .end:
 pop ebp
 pop edx
 pop ebx
 pop eax
ret












;Example: Print the numeric value in ESI:
;
;  mov eax,esi   ;Pass value to EAX
;  mov ebp,-1    ;Set the mask in EBP to allow printing all 32 bits
;  call _tmp_prn_bindechex


;Use PHP-like documentation, which explains
;function definitions, external details
;and internals to fully understand any
;possible situation that a function could
;cause or expose, almost always as clear
;as to reimplement it.


;This function converts EAX to a binary,
;decimal and hexadecimal string, and
;uses EBP as an AND mask to limit the
;maximum bits to convert (the default
;is the full 32 bits).
;
_tmp_prn_bindechex:
 owide pushf
 push wideax
 push widebx
 push widesi
 push widedi

 ;//Adjust the value to the specified
 ;//byte, word or dword value limit:
 ;;
  and eax,ebp;


;/*
; Inputs:
;        BL  -- base to convert to
;        EAX -- binary value to convert to string
;        EDI -- end of intended string
;
; Outputs:
;        ECX -- lenght of string
;        EDI -- start of the generated string
;
;*/
 push wideax
 mov bl,2
 mov edi,_tmp_prn_bindechex__binstr+127;
 call num2str

 xchg esi,edi


  push wideax
  push widedx
  mov ah,9
  mov edx,esi
  int 21h
  pop widedx
  pop wideax



  push wideax
  push widedx
  mov ah,9
  mov dx,rnstr
  int 21h
  pop widedx
  pop wideax
 xchg esi,edi
 pop wideax



 push wideax
 mov bl,10
 mov edi,_tmp_prn_bindechex__decstr+127;
 call num2str

 xchg esi,edi
  push wideax
  push widedx
  mov ah,9
  mov edx,esi
  int 21h
  pop widedx
  pop wideax

  push wideax
  push widedx
  mov ah,9
  mov dx,rnstr
  int 21h
  pop widedx
  pop wideax
 xchg esi,edi
 pop wideax


 push wideax
 mov bl,16
 mov edi,_tmp_prn_bindechex__hexstr+127;
 call num2str

 xchg esi,edi
  push wideax
  push widedx
  mov ah,9
  mov edx,esi
  int 21h
  pop widedx
  pop wideax

  push wideax
  push widedx
  mov ah,9
  mov dx,rnstr
  int 21h
  pop widedx
  pop wideax
 xchg esi,edi
 pop wideax



 pop widedi
 pop widesi
 pop widebx
 pop wideax
 owide popf
retwide






_tmp_prn_bindechex__hexstr times 128 db 0
db "h"
dd 0

_tmp_prn_bindechex__decstr times 128 db 0
db 0
dd 0


_tmp_prn_bindechex__binstr times 128 db 0
db "b"
dd 0




;EOF































































sbtest0errstr db "Error resetting or getting DSP version.$",0

rnstr db 10,13,"$"


;EOF